
from typing import Any

from discord import Guild, Member, User
from redbot.core import commands
from redbot.core.bot import Red


class Type(object):
    moderation_type = None
    verb = None
    embed_desc = "been"

    def __str__(self) -> str:
        return self.type

    @classmethod
    async def handler(cls, ctx: commands.Context, target: Member | User, silent: bool, **kwargs) -> 'Type': # pylint: disable=unused-argument
        """This method should be overridden by any child classes, but should retain the same starting keyword arguments."""
        raise NotImplementedError

    @classmethod
    async def resolve_handler(cls, bot: Red, guild: Guild, target: Member | User, reason: str | None = None) -> Any: # pylint: disable=unused-argument
        """This method should be overridden by any resolvable child classes, but should retain the same keyword arguments.
        If your moderation type should not be resolvable, do not override this."""
        raise NotImplementedError

    @classmethod
    async def expiry_handler(cls, bot: Red, guild: Guild, target: Member | User) -> Any: # pylint: disable=unused-argument
        """This method should be overridden by any expirable child classes, but should retain the same keyword arguments.
        If your moderation type should not expire, do not override this."""
        raise NotImplementedError
